#include <bits/stdc++.h>

#define int long long
#define double long double
#define F first
#define S second
using namespace std;

struct Vector {
    double x, y;

    double operator*(Vector o) {
        return x * o.x + y * o.y;
    }

    double operator%(Vector o) {
        return x * o.y - y * o.x;
    }

    Vector operator-(Vector o) {
        return {x - o.x, y - o.y};
    }

    Vector operator+(Vector o) {
        return {x + o.x, y + o.y};
    }

    double sqrlen() {
        return x * x + y * y;
    }

    double len() {
        return sqrtl(sqrlen());
    }
};

struct Line {
    double a, b, c;

    double res(Vector o) {
        return a * o.x + b * o.y + c;
    }
};

double dist(Vector a, Vector b) {
    Vector c = a - b;
    return c.len();
}

void solve() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    vector<int> p (n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    int fac = 1;
    for (int i = 2; i <= n; ++i) {
        fac *= n;
    }
    double ans = 1e18;
    for (int i = 0; i < fac; ++i) {
        double res = 0;
        Line l = {a[p[0]].y - a[p[1]].y, a[p[1]].x - a[p[0]].x, -l.a * a[p[0]].x - l.b * a[p[0]].y};
        res += dist(a[p[0]], a[p[1]]);
        Line h = {-l.b, l.a};
        for (int j = 2; j < n; ++j) {
            double v = h.res(a[p[j]]);
            h.c -= v;

            double x = -(l.c * h.b - h.c * l.b) / (l.a * h.b - h.a * l.b);
            double y = -(l.a * h.c - h.a * l.c) / (l.a * h.b - h.a * l.b);
            res += dist(a[p[j - 1]], {x, y});
            res += dist(a[p[j]], {x, y});

            v = l.res(a[p[j]]);
            l.c -= v;
        }
        ans = min(ans, res);
        next_permutation(p.begin(), p.end());
    }
    cout << fixed << setprecision(10) << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}